VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFlexSpread"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'---------------------------------------------------------------------------------------
' Module    : clsFlexSpread
' DateTime  : 14-1-2004 00:29
' Author    : FlyGuy
'---------------------------------------------------------------------------------------
Option Explicit

Private WithEvents m_txtCell As TextBox
Attribute m_txtCell.VB_VarHelpID = -1
Private WithEvents m_flexGrid As VBFlexGrid
Attribute m_flexGrid.VB_VarHelpID = -1
Private WithEvents m_Eval As ScriptControl
Attribute m_Eval.VB_VarHelpID = -1

' to store the row/column of the cell being edited
Private m_lCellCol As Long
Private m_lCellRow As Long
Private m_bAutoEdit As Boolean
Private m_bSelf As Boolean
Private m_sNumberFormat As String

Private m_aFormula() As String

Event BeforeEdit(Row As Long, Col As Long, ByRef Cancel As Boolean)
Event AfterEdit(Row As Long, Col As Long)
Event EvalError(Row As Long, Col As Long)

' Public Class Properties
Public Property Set EditBox(objValue As TextBox)
  Set m_txtCell = objValue
  With m_txtCell
    .Visible = False
    .BorderStyle = 0
    .Visible = False
    ' set the text background color to the
    ' backcolor of the tooltip text to make
    ' the cell being edited having a different color
    '.BackColor = vbInfoBackground
  End With
End Property

Public Property Set Grid(objValue As VBFlexGrid)
  Set m_flexGrid = objValue
  ReDim m_aFormula(m_flexGrid.Rows, m_flexGrid.Cols)
End Property

Public Property Set Parser(objValue As ScriptControl)
  Set m_Eval = objValue
End Property

Public Property Let AutoEdit(ByVal bValue As Boolean)
  m_bAutoEdit = bValue
End Property

Public Property Get AutoEdit() As Boolean
  AutoEdit = m_bAutoEdit
End Property

Public Property Let NumberFormat(ByVal sValue As String)
  m_sNumberFormat = sValue
End Property

Public Property Get NumberFormat() As String
  NumberFormat = m_sNumberFormat
End Property

Public Property Let TextFormula(ByVal lRow As Long, ByVal lCol As Long, sValue As String)
  If lRow <= m_flexGrid.Rows And lCol <= m_flexGrid.Cols And _
    lRow >= 0 And lCol >= 0 Then
      m_aFormula(lRow, lCol) = sValue
      m_lCellCol = lCol
      m_lCellRow = lRow
      m_flexGrid.TextMatrix(lRow, lCol) = ParseText(sValue)
      m_lCellCol = -1
      m_lCellRow = -1
  Else
    Err.Raise 9
  End If
End Property

Public Property Get TextFormula(ByVal lRow As Long, ByVal lCol As Long) As String
  TextFormula = m_aFormula(lRow, lCol)
End Property

' Private Class Events
Private Sub m_flexGrid_Click()
  If m_bAutoEdit Then showTxtCell
End Sub

Private Sub m_flexGrid_DblClick()
  If Not m_bAutoEdit Then showTxtCell
End Sub

Private Sub m_flexGrid_RowColChange()
  removeTxtCell
  If m_bAutoEdit Then showTxtCell
End Sub

Private Sub m_flexGrid_Scroll()
  removeTxtCell
End Sub

Private Sub m_flexGrid_SelChange()
  If Not m_bAutoEdit Then removeTxtCell
End Sub

Private Sub m_Eval_Error()
  RaiseEvent EvalError(m_lCellRow, m_lCellCol)
End Sub

Private Sub m_txtCell_Change()
  m_flexGrid.Text = m_txtCell.Text
End Sub

Private Sub m_txtCell_KeyDown(KeyCode As Integer, Shift As Integer)
  If Shift = 0 Then
    With m_flexGrid
      
      Select Case KeyCode
        
        Case vbKeyUp
          KeyCode = 0
          If .Row > .FixedRows Then .Row = .Row - 1 Else .Row = .Rows - 1
        
        Case vbKeyDown
          KeyCode = 0
          If .Row < .Rows - 1 Then .Row = .Row + 1 Else .Row = .FixedRows
        
        Case vbKeyLeft
          If m_txtCell.SelStart = 0 Then
            KeyCode = 0
            If .Col > .FixedCols Then .Col = .Col - 1
          End If
        
        Case vbKeyRight
          If m_txtCell.SelStart = Len(m_txtCell.Text) Then
            KeyCode = 0
            If .Col < .Cols - 1 Then .Col = .Col + 1
          End If
      
      End Select
    End With
  End If
End Sub

Private Sub m_txtCell_KeyPress(KeyAscii As Integer)
  If KeyAscii = 13 Then
    KeyAscii = 0
    removeTxtCell
    If m_flexGrid.Row < m_flexGrid.Rows - 1 Then
      m_flexGrid.Row = m_flexGrid.Row + 1
    End If
  End If
End Sub

Private Sub m_txtCell_Validate(Cancel As Boolean)
  removeTxtCell
End Sub

' Private Class Functions
Private Sub showTxtCell()
  Dim bCancel As Boolean
  
  If m_bSelf Then Exit Sub
  If m_lCellRow <> -1 Then Exit Sub
  
  On Error GoTo showTxtCell_Error

  With m_flexGrid
    ' store the current row and column
    m_lCellRow = .Row
    m_lCellCol = .Col
    
    RaiseEvent BeforeEdit(m_lCellRow, m_lCellCol, bCancel)
    
    If bCancel Then
      
      m_lCellRow = -1
    
    Else
      m_txtCell.Text = m_aFormula(m_lCellRow, m_lCellCol)
      
      ' make sure the cell is visible
      m_bSelf = True
      Do Until .RowIsVisible(m_lCellRow) Or .RowIsVisible(.Rows - 1)
        .TopRow = .TopRow + 1
      Loop
      Do Until .RowIsVisible(m_lCellRow) Or .RowIsVisible(.FixedRows)
        .TopRow = .TopRow - 1
      Loop
      Do Until .ColIsVisible(m_lCellCol) Or .ColIsVisible(.Cols - 1)
        .LeftCol = .LeftCol + 1
      Loop
      Do Until .ColIsVisible(m_lCellCol) Or .ColIsVisible(.FixedCols)
        .LeftCol = .LeftCol - 1
      Loop
      m_bSelf = False
      
      ' move the textbox to the correct cell
      '''m_txtCell.Move .Left + .CellLeft, .Top + .CellTop, .CellWidth, .CellHeight
      m_txtCell.Move .Left + .CellLeft, .Top + .CellTop, .CellWidth - 15, .CellHeight - 15
    End If
  End With
  
  If Not bCancel Then
    With m_txtCell
      ' select all text
      If Len(.Text) > 0 Then
        .SelStart = 0
        .SelLength = Len(.Text)
      End If
      .Visible = True
      .ZOrder
      .SetFocus
    End With
  End If
    
  On Error GoTo 0
  Exit Sub

showTxtCell_Error:
  Err.Raise 1001, "clsFlexSpread", "Grid dimensions have changed!"
End Sub

Private Sub removeTxtCell()
  
  If m_bSelf Then Exit Sub
  
  If m_lCellRow <> -1 Then
    m_flexGrid.TextMatrix(m_lCellRow, m_lCellCol) = ParseText(m_txtCell.Text)
    RaiseEvent AfterEdit(m_lCellRow, m_lCellCol)
    m_lCellRow = -1
    m_lCellCol = -1
    m_txtCell.Visible = False
  End If
End Sub

Private Function ParseText(ByVal sText As String) As String
  Dim sFunction As String
  Dim sParam As String
  Dim sTemp As String
  
  ' by default we return the given text
  
  ParseText = sText
  
  ' store the orginal text in the formula array
  m_aFormula(m_lCellRow, m_lCellCol) = sText
  
  If Len(Trim$(sText)) = 0 Then Exit Function
  If IsNumeric(sText) Then Exit Function
  If Left$(sText, 1) <> "=" Then Exit Function
  
  ' do we have a range function?
  sTemp = UCase$(Mid$(sText, 2, 3))
  If sTemp = "SUM" Or sTemp = "AVG" Then
    sFunction = sTemp
    sParam = Mid$(sText, 6, Len(sText) - 6)
    ParseText = ParseFunction(sFunction, sParam)
  Else
  ' Maybe it can be evaluated
    ParseText = ParseEvaluate(Mid$(sText, 2))
  End If
  
  If ParseText = "#ERR!" Then RaiseEvent EvalError(m_lCellRow, m_lCellCol)
  
End Function

Private Function ParseFunction(sFunction As String, ByVal sParams As String) As String
  Dim bRange As Boolean
  
  ' By default we asume it's an error ;-)
  ParseFunction = "#ERR!"
  
  On Error GoTo ParseFunction_Error
  
  sParams = Replace$(sParams, ";", ":")
  bRange = InStr(1, sParams, ":", vbBinaryCompare) > 0
  
  If bRange Then
    ParseFunction = ParseRange(sFunction, sParams)
  End If
  On Error GoTo 0
  
  Exit Function

ParseFunction_Error:
  
End Function

Private Function ParseRange(sFunction As String, ByVal sParams As String) As String
  Dim aSplitted() As String
  Dim sCellFrom As String
  Dim sCellTo As String
  Dim lColStart As Long, lColEnd As Long
  Dim lRowStart As Long, lRowEnd As Long
  Dim lCol As Long, lRow As Long
  Dim dSum As Double
  Dim lCnt As Long
  
  ' By default we asume it's an error ;-)
  ParseRange = "#ERR!"
  
  On Error GoTo ParseRange_Error
  
  sParams = Replace$(sParams, ";", ":")
  
  ' cell pairs delimited by :
  aSplitted = Split(sParams, ":")
  If UBound(aSplitted) <> 1 Then Exit Function
  
  sCellFrom = aSplitted(0)
  sCellTo = aSplitted(1)
  
  If GetRowCol(sCellFrom, lRowStart, lColStart) Then
  
    If GetRowCol(sCellTo, lRowEnd, lColEnd) Then
  
      With m_flexGrid
        For lRow = lRowStart To lRowEnd
          If lRow >= 0 And lRow < .Rows Then
            For lCol = lColStart To lColEnd
              If lCol >= 0 And lCol < .Cols Then
                If IsNumeric(.TextMatrix(lRow, lCol)) Then
                  dSum = dSum + CDbl(.TextMatrix(lRow, lCol))
                  lCnt = lCnt + 1
                End If
              End If
            Next lCol
          End If
        Next lRow
      End With
  
      Select Case UCase$(sFunction)
        Case "SUM"
          ParseRange = Format(dSum, m_sNumberFormat)
        Case "AVG"
          If lCnt <> 0 Then
            ParseRange = Format((dSum / lCnt), m_sNumberFormat)
          Else
            RaiseEvent EvalError(m_lCellRow, m_lCellCol)
            ParseRange = "#DIV0!"
          End If
      End Select
    End If
  End If
  On Error GoTo 0
  Exit Function

ParseRange_Error:

End Function

Private Function ParseEvaluate(ByVal sEval As String) As String
  Dim sValue As String
  Dim lPos As Long, lPos2 As Long
  Dim sTemp As String
  
  ParseEvaluate = "#ERR!"
  
  ' First replace all [x,y] with actual grid values
  lPos = InStr(1, sEval, "[", vbBinaryCompare)
  Do While lPos > 0
    lPos2 = InStr(lPos + 1, sEval, "]", vbBinaryCompare)
    If lPos2 > 0 Then
      sTemp = Mid$(sEval, lPos + 1, lPos2 - lPos - 1)
      If GetValue(sTemp, sValue) Then
        sEval = Replace$(sEval, "[" & sTemp & "]", sValue, , , vbBinaryCompare)
        ' search for the next [x,y]
        lPos = InStr(1, sEval, "[", vbBinaryCompare)
      Else
        lPos = 0
      End If
    Else
      lPos = 0
    End If
  Loop
  
  On Error Resume Next
  
  sTemp = m_Eval.Eval(sEval)
  If Err.Number = 0 Then
    If Len(sTemp) > 0 Then
      If IsNumeric(sTemp) Then
        ParseEvaluate = Format(CDbl(sTemp), m_sNumberFormat)
      End If
    End If
  End If
  
End Function

Private Function GetRowCol(ByVal sText As String, ByRef Row As Long, ByRef Col As Long) As Boolean
  Dim lPos As Long
  
  On Error GoTo GetRowCol_Error

  sText = Replace$(sText, "[", "")
  sText = Replace$(sText, "]", "")
  
  lPos = InStr(1, sText, ",", vbBinaryCompare)
  If lPos > 0 Then
    Row = CLng(Left$(sText, lPos - 1))
    Col = CLng(Mid$(sText, lPos + 1))
  End If

  GetRowCol = True
  
  On Error GoTo 0
  Exit Function

GetRowCol_Error:
  
End Function

Private Function GetValue(ByVal sText As String, ByRef sValue As String) As Boolean
  Dim lPos As Long
  Dim lRow As Long, lCol As Long
  
  On Error GoTo GetValue_Error

  sText = Replace$(sText, "[", "")
  sText = Replace$(sText, "]", "")
  
  lPos = InStr(1, sText, ",", vbBinaryCompare)
  If lPos > 0 Then
    lRow = CLng(Left$(sText, lPos - 1))
    lCol = CLng(Mid$(sText, lPos + 1))
    sValue = m_flexGrid.TextMatrix(lRow, lCol)
  Else
    sValue = sText
  End If

  GetValue = True
  
  On Error GoTo 0
  Exit Function

GetValue_Error:
  
End Function

' Class events
Private Sub Class_Initialize()
  m_lCellRow = -1
  m_lCellCol = -1
End Sub

Private Sub Class_Terminate()
  Set m_flexGrid = Nothing
  Set m_txtCell = Nothing
  Set m_Eval = Nothing
End Sub
